<template>
  <div></div>
</template>

<script>
// Vendor
import moment from 'moment'
import { tileLayer } from 'leaflet'

// Mixins
import ParentWorkspaceMixin from '@/dashboard/mixins/ParentWorkspace'

import { findParentComponentByName } from '@/core/util'


export default {
  name: 'leafletwmslayer',

  mixins: [
    ParentWorkspaceMixin,
  ],

  props: {
    identifier: {
      type: String,
      required: true,
    },
  },

  computed: {
    leafletMap: {
      get() {
        return findParentComponentByName(this.$parent, 'leafletmap')
      }
    },

    leafletPane: {
      get() {
        return findParentComponentByName(this.$parent, 'leafletpane')
      }
    },

    // Current status of this layer in the workspace context state
    layerStatus: {
      get() {
        return this.$store.state[this.workspace].layers.find(layer => layer.id === this.identifier).active
      },
    },

    // Layer definition with the proper settings to display the WMS layer object
    layerDefinition: {
      get() {
        return this.$store.getters.getLayerById(this.identifier)
      },
    },

    // The service URL for this layer
    serviceUrl: {
      get() {
        return this.$store.getters.getServiceById(this.layerDefinition.service).url
      },
    },

    // Reference time for the WMS request
    referenceTime: {
      get() {
        return this.$store.state[this.workspace].referenceTime
      },
    },

    // Current step used to compute the time paramenter for the WMS request
    step: {
      get() {
        return this.$store.state[this.workspace].step
      },
    },

    pressureLevel: {
      get() {
        return this.$store.state[this.workspace].pressureLevel
      }
    },
  },

  watch: {
    // Watcher method for the layer status. Adds or removes the layer from the parent
    // map object depending on the current status in this workspace.
    layerStatus(after) {
      if(after) {
        this.add()
      } else {
        this.remove()
      }
    },

    // Watcher method for the reference time used in the WMS requests.
    referenceTime(after) {
      if(this.serviceUrl.includes('mf2.ipma.pt')) {
        this.layerObject.setParams({
          reference_time: moment.unix(after).format('YYYY-MM-DDTHH:00:00'),
          time: this.computeTimeParameter(after, this.step)
        })
      } else {
        this.layerObject.setParams({
          dim_reference_time: moment.unix(after).format('YYYY-MM-DDTHH:00:00'),
          time: this.computeTimeParameter(after, this.step)
        })
      }
    },

    // Watcher method for the current step, used to compute the time parameter
    // used in the WMS requests.
    step(after) {
      if(this.serviceUrl.includes('mf2.ipma.pt')) {
        this.layerObject.setParams({
          reference_time: moment.unix(this.referenceTime).format('YYYY-MM-DDTHH:00:00'),
          time: this.computeTimeParameter(this.referenceTime, after)
        })
      } else {
        this.layerObject.setParams({
          dim_reference_time: moment.unix(this.referenceTime).format('YYYY-MM-DDTHH:00:00'),
          time: this.computeTimeParameter(this.referenceTime, after)
        })
      }
    },

    pressureLevel(after) {
      this.layerObject.setParams({
        dim_pressure_level: after
      })
    },
  },

  methods: {
    create() {
      this.layerObject = tileLayer.wms(this.serviceUrl, this.getOptions())
      if(this.layerStatus) this.add()
      return this
    },

    getOptions() {
      if(this.serviceUrl.includes('mf2.ipma.pt')) {
        return {
          version: '1.3.0',
          tileSize: 512,
          pane: this.leafletPane.name,
          layers: this.layerDefinition.name,
          format: 'image/png',
          transparent: true,
          reference_time: moment.unix(this.referenceTime).format('YYYY-MM-DDTHH:00:00[Z]'),
          dim_pressure_level: this.pressureLevel,
          time: this.computeTimeParameter(this.referenceTime, this.step),
        }
      } else {
        return {
          version: '1.3.0',
          tileSize: 512,
          pane: this.leafletPane.name,
          layers: this.layerDefinition.name,
          format: 'image/png',
          transparent: true,
          dim_reference_time: moment.unix(this.referenceTime).format('YYYY-MM-DDTHH:00:00[Z]'),
          dim_pressure_level: this.pressureLevel,
          time: this.computeTimeParameter(this.referenceTime, this.step),
        }
      }
    },

    add() {
      this.layerObject.addTo(this.leafletMap.mapObject)
      return this
    },

    remove() {
      this.layerObject.remove()
      return this
    },

    computeTimeParameter(referenceTime, step) {
      let hasTimeResolution = this.layerDefinition.time_resolution !== null
      let baseTime = moment.unix(referenceTime).add(step, 'hours')

      if(hasTimeResolution) {
        return baseTime.format('YYYY-MM-DDTHH:00:00[Z]') + '/' + baseTime.clone().add(this.layerDefinition.time_resolution, 'm').format('YYYY-MM-DDTHH:mm:00[Z]')
      } else {
        return baseTime.format('YYYY-MM-DDTHH:00:00')
      }
    },
  },

  mounted() {
    this.create()
  },
}
</script>
